# SPDX-FileCopyrightText: 2023 Daniel Wolf <nephatrine@gmail.com>
#
# SPDX-License-Identifier: ISC

set(CMAKE_SYSTEM_NAME "DOS")
set(CMAKE_SYSTEM_PROCESSOR "i586")
set(CMAKE_SIZEOF_VOID_P 4)

set(triplet "${CMAKE_SYSTEM_PROCESSOR}-pc-msdosdjgpp")

set(CMAKE_SYSROOT "$ENV{DJGPP_SYSROOT}")
list(APPEND CMAKE_PREFIX_PATH "$ENV{DJGPP_PREFIX}" "$ENV{DJGPP_PREFIX}/${triplet}")

find_program(CMAKE_C_COMPILER NAMES "${triplet}-gcc")
find_program(CMAKE_CXX_COMPILER NAMES "${triplet}-g++")

find_program(CMAKE_AR NAMES "${triplet}-gcc-ar" "${triplet}-ar")
find_program(CMAKE_RANLIB NAMES "${triplet}-gcc-ranlib" "${triplet}-ranlib")
find_program(CMAKE_STRIP NAMES "${triplet}-strip")
find_program(CMAKE_LINKER NAMES "${triplet}-ld")
find_program(CMAKE_NM NAMES "${triplet}-gcc-nm" "${triplet}-nm")
find_program(CMAKE_OBJDUMP NAMES "${triplet}-objdump")
find_program(CMAKE_OBJCOPY NAMES "${triplet}-objcopy")
find_program(CMAKE_READELF NAMES "${triplet}-readelf")
find_program(CMAKE_ADDR2LINE NAMES "${triplet}-addr2line")
find_program(CMAKE_DXE3GEN NAMES "${triplet}-dxe3gen" "dxe3gen")
find_program(CMAKE_DXE3RES NAMES "${triplet}-dxe3res" "dxe3res")

set(CMAKE_C_COMPILER_TARGET "${triplet}")
set(CMAKE_CXX_COMPILER_TARGET "${triplet}")
set(CMAKE_ASM_COMPILER_TARGET "${triplet}")

set(CMAKE_SYSTEM_INCLUDE_PATH /include)
set(CMAKE_SYSTEM_LIBRARY_PATH /lib)
set(CMAKE_SYSTEM_PROGRAM_PATH /bin)
